Index: trunk/LMDZ.GENERIC/libf/aeronostd/read_phototable.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/read_phototable.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/read_phototable.F90	(revision 2542)
@@ -13,9 +13,10 @@
 !
 !   Author:   Franck Lefevre
+!   update 06/03/2021 dimension set in table + CH4 dimension + photoheat (Yassin Jaziri)
 !
 !   Arguments:
 !   ----------
 !
-!   The output variable is jphot and is put in common chimiedata.
+!   The output variable is jphot/ephot and is put in common chimiedata.
 !
 !***********************************************************************
@@ -24,7 +25,9 @@
       use ioipsl_getin_p_mod, only: getin_p
       use datafile_mod
+      use callkeys_mod
+      use chimiedata_h
       implicit none
 
-#include "chimiedata.h"
+!#include "chimiedata.h"
 
 !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
@@ -32,8 +35,9 @@
 !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 
-      integer :: fic, ij, iozo, isza, itemp, iz, itau, ierr
-      real    :: xsza
+      integer :: fic, ij, iozo, isza, itemp, iz, itau, ich4, ierr
+      real    :: xsza, dummy
 
       character(len = 128) :: phototable ! photolysis table file name
+      character(len = 128) :: ephototable ! energie photolysis table file name
 
 !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
@@ -73,15 +77,27 @@
       print*, 'read photolysis lookup table ',trim(phototable)
 
+      read(fic,*) nz, nsza, nozo, dummy, ntemp, ntau, nch4, nd
+
+      allocate(jphot(ntemp,nsza,nz,nozo,ntau,nch4,nd))
+      allocate(ephot(ntemp,nsza,nz,nozo,ntau,nch4,nd))
+      allocate(colairtab(nz))
+      allocate(szatab(nsza))
+      allocate(table_ozo(nozo))
+      allocate(tautab(ntau))
+      allocate(table_ch4(nch4))
+
       do itau = 1,ntau
          do itemp = 1,ntemp
             do iozo = 1,nozo
-               do isza = 1,nsza
-                  do iz = nz,1,-1
-                     read(fic,*) colairtab(iz), xsza, table_ozo(iozo)
-                     read(fic,'(7e11.4)') (jphot(itemp,isza,iz,iozo,itau,ij), ij= 1,nd)
-                     do ij = 1,nd
-                        if (jphot(itemp,isza,iz,iozo,itau,ij) == 1.e-30) then
-                           jphot(itemp,isza,iz,iozo,itau,ij) = 0.
-                        end if
+               do ich4 =1,nch4
+                  do isza = 1,nsza
+                     do iz = nz,1,-1
+                        read(fic,*) colairtab(iz), szatab(isza),table_ozo(iozo), dummy, dummy, dummy, table_ch4(ich4)
+                        read(fic,'(7e11.4)') (jphot(itemp,isza,iz,iozo,itau,ich4,ij), ij= 1,nd)
+                        do ij = 1,nd
+                           if (jphot(itemp,isza,iz,iozo,itau,ich4,ij) == 1.e-30) then
+                              jphot(itemp,isza,iz,iozo,itau,ich4,ij) = 0.
+                           end if
+                        end do
                      end do
                   end do
@@ -94,4 +110,65 @@
       close(fic)
 
+      if (photoheat) then 
+!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+! set energie photolysis table input file name
+!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+
+
+! look for a " ephototable= ..." option in def files
+     write(*,*) "Directory where external input files are:"
+      ephototable = "zdtearth_N+_CO2_0.0004_O2_0.21_G11" ! default
+     call getin_p("ephototable",ephototable) ! default path
+     write(*,*) " ephototable = ",trim(ephototable)
+
+
+      fic = 81
+
+      open(fic, form = 'formatted', status = 'old',                &
+           file =trim(datadir)//"/"//trim(ephototable),iostat=ierr)
+
+      if (ierr /= 0) THEN
+        write(*,*)'Error : cannot open energie photolysis lookup table ', trim(ephototable)
+        write(*,*)'It should be in :',trim(datadir),'/'
+        write(*,*)'1) You can change this directory in callphys.def'
+        write(*,*)'   with:'
+        write(*,*)'   datadir=/path/to/the/directory'
+        write(*,*)'2) You can change the input ephototable file name in'
+        write(*,*)'   callphys.def with:'
+        write(*,*)'   ephototable=filename'
+        stop
+      end if
+
+!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+! read energie photolys table
+!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+      print*, 'read energie photolysis lookup table ',trim(ephototable)
+
+      do itau = 1,ntau
+         do itemp = 1,ntemp
+            do iozo = 1,nozo
+               do ich4 =1,nch4
+                  do isza = 1,nsza
+                     do iz = nz,1,-1
+                        read(fic,*) colairtab(iz), xsza,table_ozo(iozo), dummy, dummy, dummy, table_ch4(ich4)
+                        read(fic,'(7e11.4)') (ephot(itemp,isza,iz,iozo,itau,ich4,ij), ij= 1,nd)
+                        do ij = 1,nd
+                           if (ephot(itemp,isza,iz,iozo,itau,ich4,ij) == 1.e-30) then
+                              ephot(itemp,isza,iz,iozo,itau,ich4,ij) = 0.
+                           end if
+                        end do
+                     end do
+                  end do
+               end do
+            end do
+         end do
+      end do
+
+      print*, 'lookup etable...ok'
+      close(fic)
+      end if
+
       return
       end
Index: trunk/LMDZ.GENERIC/libf/aeronostd/types_asis.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/types_asis.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/types_asis.F90	(revision 2542)
@@ -7,20 +7,20 @@
 
 type z3spec
-	real(kind=jprb)    :: z1
-        integer(kind=jpim) :: z2
-	real(kind=jprb)    :: z3
-        integer(kind=jpim) :: z4
-	real(kind=jprb)    :: z5
-        integer(kind=jpim) :: z6
+    real(kind=jprb)    :: z1
+    integer(kind=jpim) :: z2
+    real(kind=jprb)    :: z3
+    integer(kind=jpim) :: z4
+    real(kind=jprb)    :: z5
+    integer(kind=jpim) :: z6
 end type z3spec
 type z4spec
-	real(kind=jprb)    :: z1
-        integer(kind=jpim) :: z2
-	real(kind=jprb)    :: z3
-        integer(kind=jpim) :: z4
-	real(kind=jprb)    :: z5
-        integer(kind=jpim) :: z6
-	real(kind=jprb)    :: z7
-        integer(kind=jpim) :: z8
+    real(kind=jprb)    :: z1
+    integer(kind=jpim) :: z2
+    real(kind=jprb)    :: z3
+    integer(kind=jpim) :: z4
+    real(kind=jprb)    :: z5
+    integer(kind=jpim) :: z6
+    real(kind=jprb)    :: z7
+    integer(kind=jpim) :: z8
 end type z4spec
 
@@ -31,3 +31,70 @@
 type(z4spec), allocatable, save :: indice_4(:)
 
+! dimension of indexes variables
+
+integer, save :: nb_phot_max       ! dimension of phot reaction, including photolysis and quenching reaction
+integer, save :: nb_reaction_3_max
+integer, save :: nb_reaction_4_max
+integer, save :: nb_phot_hv_max    ! dimension of photolysis, including three product photolysis
+
+! photolysis reaction rate and label
+
+real (kind = 8),      allocatable, save :: v_phot_3d(:,:,:)
+character(len = 20),  allocatable, save :: jlabel(:,:)        ! photolysis label and species name
+character(len = 300), allocatable, save :: jparamline(:)      ! line of jonline parameters
+
+! pfunc type
+
+type rtype1
+    real(kind=jprb)    :: a
+    real(kind=jprb)    :: b
+    real(kind=jprb)    :: c
+    real(kind=jprb)    :: t0
+    real(kind=jprb)    :: d
+end type rtype1
+
+type rtype2
+    real(kind=jprb)    :: k0
+    real(kind=jprb)    :: n
+    real(kind=jprb)    :: a
+    real(kind=jprb)    :: kinf
+    real(kind=jprb)    :: m
+    real(kind=jprb)    :: b
+    real(kind=jprb)    :: t0
+    real(kind=jprb)    :: fc
+    real(kind=jprb)    :: g
+    real(kind=jprb)    :: h
+    real(kind=jprb)    :: dup
+    real(kind=jprb)    :: ddown
+end type rtype2
+
+type rtype3
+    real(kind=jprb)    :: k0
+    real(kind=jprb)    :: n
+    real(kind=jprb)    :: a
+    real(kind=jprb)    :: kinf
+    real(kind=jprb)    :: m
+    real(kind=jprb)    :: b
+    real(kind=jprb)    :: t0
+    real(kind=jprb)    :: atroe
+    real(kind=jprb)    :: btroe
+    real(kind=jprb)    :: ctroe
+    real(kind=jprb)    :: dtroe
+    real(kind=jprb)    :: dup
+    real(kind=jprb)    :: ddown
+end type rtype3
+
+! pfunc parameters for the reaction rates
+
+type(rtype1), allocatable, save :: pfunc1_param(:)
+type(rtype2), allocatable, save :: pfunc2_param(:)
+type(rtype3), allocatable, save :: pfunc3_param(:)
+
+! dimension of pfunc type variables
+
+integer, save :: nb_hv_max
+integer, save :: nb_pfunc1_max
+integer, save :: nb_pfunc2_max
+integer, save :: nb_pfunc3_max
+
 end module types_asis
